package fr.inra.pappso.xtandempipeline.class_msms.IdentificationDataFile;

import java.io.File;
import java.util.HashMap;
import java.util.HashSet;

import org.apache.log4j.Logger;

public class IdentificationDataSourceSet extends
		HashSet<IdentificationDataSource> {

	private static final long serialVersionUID = -4351959247611214080L;

	private static final Logger logger = Logger
			.getLogger(IdentificationDataSourceSet.class);

	private HashMap<String, IdentificationDataSource> stringToDatasource = new HashMap<String, IdentificationDataSource>();

	public IdentificationDataSourceSet() {
	}

	public IdentificationDataSource getInstance(String source) {
		//If exist, return instance
		if(stringToDatasource.containsKey(source))
			return stringToDatasource.get(source);
		
		//If not exist create correct instance
		IdentificationDataSource dataSource =null;
		if(source.matches(".*dat$")){
			dataSource = new IdentificationMascotFile(new File(source));
			stringToDatasource.put(source, dataSource);
		//}else if(source.matches(".*xml$")){		
		}else{
			dataSource = new IdentificationXtandemFile(new File(source));
		}
		stringToDatasource.put(source, dataSource);
		logger.debug("New Datasource :"+source);
		return(dataSource);
	}
	
}
