package fr.inra.pappso.xtandempipeline.class_msms.IdentificationDataFile;

import java.io.File;

import javax.xml.stream.XMLStreamWriter;

import fr.inra.pappso.xtandempipeline.class_msms.Identification;
import fr.inra.pappso.xtandempipeline.class_msms.Peptide;
import fr.inra.pappso.xtandempipeline.sax_parse.XtandemPhospho;
import fr.inra.pappso.xtandempipeline.sax_parse.parse_file;
import fr.inra.pappso.xtandempipeline.sax_parse.xtandem;
import fr.inra.pappso.xtandempipeline.sax_parse.xtandem_ms2_spectra;

public class IdentificationXtandemFile extends IdentificationDataFile {

	public IdentificationXtandemFile (File xtandemFile) {
		this.file = xtandemFile;
	}

	@Override
	public Identification loadIdentification(
			Identification previousIdentification) throws Exception {
		xtandem tandem = new xtandem(previousIdentification, this);
		new parse_file(tandem, this);
		previousIdentification = tandem.get_identifications();
		return previousIdentification;
	}
	
	@Override
	public Identification loadPhosphoIdentification(
			Identification previousIdentification) throws Exception {
		XtandemPhospho tandem = new XtandemPhospho(previousIdentification, this);
		new parse_file(tandem, this);
		previousIdentification = tandem.get_identifications();
		return previousIdentification;
	}

	@Override
	public void writeXpipPeptideSourceAttribute(XMLStreamWriter writer)
			throws Exception {
		writer.writeAttribute("sample_file", this.file.getAbsolutePath());
	}
	
	@Override
	public boolean loadMSMSSpectra(Peptide pep) throws Exception{
		new parse_file(new xtandem_ms2_spectra(pep), this);
		return true;
	}
}
