package fr.inra.pappso.xtandempipeline.class_msms;

import java.util.HashSet;

import org.apache.log4j.Logger;

import fr.inra.pappso.xtandempipeline.class_msms.IdentificationDataFile.IdentificationDataSource;

public class MsRun implements Comparable<MsRun>{
	private static final Logger logger = Logger.getLogger(MsRun.class);
	private String sample;

	private HashSet<IdentificationDataSource> files = new HashSet<IdentificationDataSource>(0);

	public MsRun(String sample_name) {
		logger.debug("MsRun begin");
		sample = sample_name;
	}

	public IdentificationDataSource addFile(IdentificationDataSource file) {
		if(files.add(file)) {
			return file;
		}
		for (IdentificationDataSource otherFile:this.files) {
			if (file.equals(otherFile)) {
				return otherFile;
			}
		}
		return null;
	}

	public String getSampleName() {
		return sample;
	}
	
	@Override
	public int hashCode() {
		return sample.hashCode();
	}
	
	@Override
	public boolean equals(Object toCompare) {
		if (this.hashCode() == toCompare.hashCode()) {
			return true;
		}
		return false;
	}

	public int compareTo(MsRun arg0) {
		return this.sample.compareTo(arg0.sample);
	}
	
}
