package fr.inra.pappso.xtandempipeline.class_msms;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;

import org.apache.log4j.Logger;

public class MsRunSet extends HashSet<MsRun>{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1859166854395591445L;
	
	private static final Logger logger = Logger.getLogger(MsRunSet.class);
	
	private HashMap<String,MsRun> name2msRun= new HashMap<String,MsRun>(0);

	public MsRunSet() {
	}

	public MsRun getInstance(String sample) {
		//Remove file extension for storing sample
		sample = sample.replaceAll("\\.xml$", "");
		sample = sample.replaceAll("\\.dat$", "");
		
		if (name2msRun.containsKey(sample)) {
			return name2msRun.get(sample);
		}
		logger.debug("add "+sample);
		MsRun msRun = new MsRun(sample);
		name2msRun.put(sample, msRun);
		this.add(msRun);
		return msRun;
	}
	
	public ArrayList<MsRun> getMsRunList(){
		ArrayList<MsRun> msRunList = new ArrayList<MsRun>(this);
		Collections.sort(msRunList);
		return (msRunList);
	}
}
