package fr.inra.pappso.xtandempipeline.filter_print;

import org.apache.log4j.Logger;

import fr.inra.pappso.xtandempipeline.class_msms.MsRun;
import fr.inra.pappso.xtandempipeline.class_msms.MsRunSet;
import fr.inra.pappso.xtandempipeline.grouping.Group;
import fr.inra.pappso.xtandempipeline.grouping.GroupSet;
import fr.inra.pappso.xtandempipeline.grouping.SubGroup;
import fr.inra.pappso.xtandempipeline.sax_parse.msms_output;

public abstract class print_base {

	protected msms_output out;

	protected MsRunSet samples;
	
	protected static final Logger logger = Logger.getLogger(print_base.class);
	
	public print_base() {
		this.out = new msms_output();
		this.samples = null;
	}


	public print_base(msms_output out) {
		this.out = out;
		this.samples = null;
	}

	public print_base(msms_output out, MsRunSet samp) {
		this.out = out;
		this.samples = samp;
	}

	public void execute(GroupSet grouping) throws Exception {
		if (this.samples == null) {
			logger.debug("Without Sample");
			this.print_header();
			for (Group group :grouping.getGroupList() ) {
				this.print_group_information(group);
			}
			this.print_footer();
		}
		else{
			logger.debug("with samples");
			for (MsRun sample : this.samples.getMsRunList()){
				this.print_header(sample);
				for (Group group :grouping.getGroupList() ) {
					this.print_group_information_to_sample(group,sample);
				}
				this.print_footer();
			}
		}
	}

	public void print_header() throws Exception {
		out.write("\n");
	}
	
	public void print_header(MsRun sample) throws Exception {
		out.write(sample.getSampleName()+"\n");
	}

	public void print_footer() throws Exception {
		out.write("\n");
	}
	
	public void print_group_information(Group group) throws Exception {

	}

	public void print_group_information_to_sample(Group groupe, MsRun sample)
			throws Exception {

	}

/*	public msms_output getOut() {
		return out;
	}

	public void setOut(msms_output out) {
		this.out = out;
	}
	*/
	protected String get_subgroup_number(Group group, SubGroup sg) {
		String subgroup = group.getNumber() + ".";
		if (sg.getNumber() < 10)
			subgroup = subgroup + "0" + sg.getNumber();
		else
			subgroup = subgroup + sg.getNumber();
		return (subgroup);
	}
}
