package fr.inra.pappso.xtandempipeline.filter_print;

import fr.inra.pappso.xtandempipeline.MsException.MSMSException;
import fr.inra.pappso.xtandempipeline.class_msms.Match;
import fr.inra.pappso.xtandempipeline.class_msms.MsRun;
import fr.inra.pappso.xtandempipeline.class_msms.MsRunSet;
import fr.inra.pappso.xtandempipeline.grouping.Group;
import fr.inra.pappso.xtandempipeline.grouping.HashSampleScan;
import fr.inra.pappso.xtandempipeline.grouping.HashSampleScanSetProt;
import fr.inra.pappso.xtandempipeline.grouping.SubGroup;
import fr.inra.pappso.xtandempipeline.sax_parse.msms_output;

public class print_pepnovo extends print_base {

	public print_pepnovo(msms_output out, MsRunSet sample) {
		super(out, sample);
		logger.info("Print PepNovo file");
	}

	public void print_header(MsRun sample) throws Exception {
		String S = "<sample file=\"" + sample.getSampleName() + "\">" + "\n";
		out.write(S);
	}

	public void print_group_information_to_sample(Group group, MsRun sample) throws MSMSException{
		for (SubGroup sg : group.getSubGroupSet()) {
			HashSampleScanSetProt hashProt =  sg.getHashSampleScanSetProtList().get(0);
			Match top = hashProt.getMatch();
			StringBuilder S = new StringBuilder("");
			int totalNumber = hashProt.getTotalHashSampleScantoMsRun(sample);
			if (totalNumber > 0) {
				S.append("<protein nb=\"" + this.get_subgroup_number(group, sg) + "\" ");
				S.append("desc=\"" + top.get_protein_match().get_description()
						+ "\" ");
				S.append("pep=\"" + totalNumber	+ "\" >" + "\n");
				S.append("<sequence>" + top.get_protein_match().get_sequence()
						+ "</sequence>" + "\n");
				for(HashSampleScan hash : hashProt){
					if(hash.getMsRun().equals(sample)){
						S .append("<scan nb=\"" + hash.getScan() + "\" />"
						+ "\n");
					}
				}
				S.append("</protein>" + "\n");
				out.write(S.toString());
			}
		}

	}

	public void print_footer() throws Exception {
		String S = "</sample>" + "\n";
		out.write(S);
	}

}
