package fr.inra.pappso.xtandempipeline.grouping;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;

import org.apache.log4j.Logger;

public class GroupSet {

	HashSet<Group> groupList = new HashSet<Group>(0);

	private static final Logger logger = Logger.getLogger(GroupSet.class);

	public GroupSet() {
		// logger.debug("SubGroup begin");
	}

	public void groupingSubGroupSet(SubGroupSet subGroupSet) throws Exception {
		logger.debug("grouping subgroup set");
		for (SubGroup subGroup : subGroupSet) {
			this.addSubGroup(subGroup);
		}
		/*
		 * for (Group group : this.groupList) { group.removeNonInformative(); }
		 */
		this.numbering();
	}

	public void numbering() {
		// numerotation
		ArrayList<Group> orderedGroupList = new ArrayList<Group>(groupList);

		Collections.sort(orderedGroupList);
		int i = 1;
		for (Group group : orderedGroupList) {
			group.setNumber(i);
			i++;
			group.getSubGroupSet().numbering();
		}

	}

	protected void addSubGroup(SubGroup subGroup) throws Exception {
		Group group = new Group(subGroup);

		this.add(group);
	}

	private boolean add(Group groupToAdd) throws Exception {
		HashSet<Group> newGroupList = new HashSet<Group>(0);
		boolean fusion = false;
		for (Group group : groupList) {
			if (groupToAdd.fusionWith(group)) {
				fusion = true;
			} else {
				newGroupList.add(group);
			}
		}
		if (fusion) {
			if (groupToAdd.removeNonInformative()) {
				newGroupList.addAll(groupToAdd.reGroup());
			}
			else {
				newGroupList.add(groupToAdd);				
			}
		}
		else  {
			newGroupList.add(groupToAdd);
		}

		this.groupList.clear();
		this.groupList.addAll(newGroupList);
		return true;

	}

	public ArrayList<Group> getGroupList() {
		ArrayList<Group> orderedGroupList = new ArrayList<Group>(groupList);

		Collections.sort(orderedGroupList);
		return orderedGroupList;
	}

	public HashSet<Group> getHashSetOfGroups() {
		return this.groupList;
	}

	public int size() {
		return this.groupList.size();
	}
}
