package fr.inra.pappso.xtandempipeline.grouping;

import org.apache.log4j.Logger;

import fr.inra.pappso.xtandempipeline.class_msms.MsRun;

public class HashPeptide extends HashKey4Groups {
	private static final Logger logger = Logger.getLogger(HashPeptide.class);
	private HashSampleScan hashSampleScan;
	private String sequence;
	private int hascode;

	// private String sequence;

	protected HashPeptide(HashSampleScan hashSampleScan, String sequence) {
		this.hashSampleScan = hashSampleScan;
		this.sequence = sequence;
		this.hascode = new String("-" + hashSampleScan.hashCode() + "-"
				+ sequence).hashCode();
	}

	@Override
	public boolean equals(Object toCompare) {
		if (this.hashCode() == toCompare.hashCode()) {
			//very good idea Benoit !
			HashPeptide toComparePeptide = (HashPeptide) toCompare;
			if ((this.hashSampleScan.equals(toComparePeptide.hashSampleScan))
					&& (this.sequence.equals(toComparePeptide.sequence))) {
				return true;
			}
		}
		return false;
	}

	@Override
	public String toString() {
		return hashSampleScan.toString() + " " + sequence;

	}

	@Override
	public int hashCode() {
		return this.hascode;
	}

	public String getSequence() {
		return sequence;
	}

	public int getScan() {
		return hashSampleScan.getScan();
	}

	public MsRun getMsRun() {
		return hashSampleScan.getMsRun();
	}

}
