package fr.inra.pappso.xtandempipeline.grouping;

import org.apache.log4j.Logger;

import fr.inra.pappso.xtandempipeline.class_msms.MsRun;

public class HashSampleScan implements Comparable<HashSampleScan> {
	private static final Logger logger = Logger.getLogger(HashSampleScan.class);

	private int scan;
	private MsRun msRun;
	private int hascode;

	// private String sequence;

	protected HashSampleScan(int scan, MsRun msRun) {
		this.scan = scan;
		this.msRun = msRun;
		this.hascode = this.getHashCodeStr().hashCode();
	}
	
	@Override
	protected void finalize() throws Throwable {
//		logger.debug("finalize HashSampleScan");
	}

	private String getHashCodeStr() {
		String code;
		if (msRun == null) {
			code = new String("-" + scan + "-" + 0);

		} else {
			code = new String("-" + scan + "-" + msRun.getSampleName());
		}
		//logger.debug("hashcode " + code);
		return code;
	}
	
//	public String getFingerPrint() {
//		return getHashCodeStr();
//	}
	
	public int compareTo(HashSampleScan p) {
		int j = this.msRun.getSampleName().compareTo(
				p.getMsRun().getSampleName());
		if (j != 0)
			return (j);
		int i = this.scan - p.getScan();
		return (i);

	}
	@Override
	public String toString() {
		return new String(scan + " " + msRun.getSampleName());
	}

	@Override
	public boolean equals(Object toCompare) {
		if (this.hashCode() == toCompare.hashCode()) {
			//logger.debug("equals on hashSampleScan "+this.toString());
			return true;
		}
		return false;
	}

	@Override
	public int hashCode() {
		return this.hascode;
	}

	public int getScan() {
		return scan;
	}

	public MsRun getMsRun() {
		return msRun;
	}

}
