package fr.inra.pappso.xtandempipeline.grouping;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;

import org.apache.log4j.Logger;

import fr.inra.pappso.xtandempipeline.class_msms.MsRun;

public class HashSampleScanSet extends HashSet<HashSampleScan> implements
		Comparable<HashSampleScanSet> {
	/**
	 * 
	 */
	private static final long serialVersionUID = -9055338154900110371L;
	private static final Logger logger = Logger
			.getLogger(HashSampleScanSet.class);

	private HashMap<Integer, HashSampleScan> getSampleScan = new HashMap<Integer, HashSampleScan>(
			0);

	public HashSampleScanSet() {
	}

	public int compareTo(HashSampleScanSet arg0) {
		int i = arg0.size() - this.size();
		if (i != 0)
			return i;
		return (this.getFingerCode() - arg0.getFingerCode());
	}

	public HashSampleScan getInstance(int scan, MsRun msRun) {
		HashSampleScan temp = new HashSampleScan(scan, msRun);

		if (this.add(temp)) {
			getSampleScan.put(temp.hashCode(), temp);
			return (temp);
		}
		return getSampleScan.get(temp.hashCode());
	}

	public void loggerDebug() {
		logger.debug("HashSampleScanSet :");
		for (HashSampleScan scan : this) {
			logger.debug(scan.toString() + " " + scan.hashCode());
		}
		// return null;
	}

	public ArrayList<HashSampleScan> getHashSampleScanList() {
		ArrayList<HashSampleScan> array = new ArrayList<HashSampleScan>(this);
		Collections.sort(array);
		return (array);
	}

	private int getFingerCode() {
		int finger = 0;
		for (HashSampleScan sampleScan : this) {
			finger += sampleScan.getScan();
		}
		return (finger);
	}

	@Override
	public void clear() {
		getSampleScan = new HashMap<Integer, HashSampleScan>(0);
		super.clear();
	}

	// private String getFingerPrint() {
	// ArrayList<String> strList = new ArrayList<String>(this.size());
	// for (HashSampleScan sampleScan:this) {
	// strList.add(sampleScan.getFingerPrint());
	// }
	// Collections.sort(strList);
	// String code = new String();
	// for (String sampleScanStr:strList) {
	// code.concat(sampleScanStr);
	// }
	//
	// return code;
	// }

}
