package fr.inra.pappso.xtandempipeline.sax_parse;

import org.apache.log4j.Logger;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

import fr.inra.pappso.xtandempipeline.class_msms.Peptide;

public class xtandem_ms2_spectra extends org.xml.sax.helpers.DefaultHandler {
	
	private static final Logger logger = Logger.getLogger(xtandem_ms2_spectra.class);
	
	private Peptide pep_;

	private String Last_element_;

	private String Start_element_;

	private String C_data;

//	private boolean is_spectra;

//	private boolean valid_spectra;

	private boolean intensity_value;

	private boolean mz_value;

	private float factor_intensity;

	public xtandem_ms2_spectra(Peptide p) {
		super();
		pep_ = p;
		logger.info("Load MSMS spectra of : "+pep_.getHashSampleScan().toString());
	}

	public void error(SAXParseException e) throws SAXParseException {
		throw e;
	}

	public void startDocument() throws SAXException {
		Last_element_ = "";
		Start_element_ = "";
		C_data = "";
//		is_spectra = false;
		intensity_value = false;
		mz_value = false;
//		valid_spectra = false;
	}

	public void endDocument() throws SAXException {
	}

	public void startElement(String namespaceURI, String simpleName,
			String qualifiedName, Attributes attrs) throws SAXException {
		Start_element_ = simpleName;
		if (Start_element_.equals(""))
			Start_element_ = qualifiedName;
		// System.out.println("Start= "+Start_element_);

		if (Start_element_.equals("group")) {
			if (attrs.getValue("type").equals("model")) {
				factor_intensity = Float.valueOf(attrs.getValue("fI"))
						.floatValue();
//			if (attrs.getValue("id").equals(""+pep_.getScan_in_xtandem()))
//				valid_spectra = true;
			}

//			if (attrs.getValue("type").equals("support")
//					&& attrs.getValue("label").equals(
//							"fragment ion mass spectrum")) {
//				is_spectra = true;
//				//valid_spectra = false;
//			}
		}

//		if (Start_element_.equals("GAML:trace") && is_spectra) {
//			if (attrs.getValue("id") != null
//					&& attrs.getValue("id").equals(
//							"" + pep_.getScan_in_xtandem()))
//				valid_spectra = true;
//		}

		if (Start_element_.equals("GAML:Xdata") && attrs.getValue("label").equals(pep_.getScan_in_xtandem()+".spectrum" )) {
			mz_value = true;
		}

		if (Start_element_.equals("GAML:Ydata") && attrs.getValue("label").equals(pep_.getScan_in_xtandem()+".spectrum" )) {
			intensity_value = true;
		}

		C_data = "";
	}

	public void endElement(String namespaceURI, String simpleName,
			String qualifiedName) throws SAXException {
		Last_element_ = simpleName;
		if (Last_element_.equals(""))
			Last_element_ = qualifiedName;

		if (Last_element_.equals("GAML:values")) {
			if (mz_value) {
				pep_.setMz_values(C_data);
				mz_value = false;
			}
			if (intensity_value) {
				pep_.setIntensity_values(C_data, factor_intensity);
				intensity_value = false;
			}
		}
//
//		if (Last_element_.equals("group")) {
//			is_spectra = false;
//			valid_spectra = false;
//		}

		C_data = "";
	}

	public void characters(char buf[], int offset, int len) throws SAXException {
		C_data = C_data + new String(buf, offset, len);
		// System.out.println(C_data);
	}
}
