package fr.inra.pappso.xtandempipeline.filter_print;

import java.util.HashSet;

import fr.inra.pappso.xtandempipeline.class_msms.Protein;
import fr.inra.pappso.xtandempipeline.grouping.Group;
import fr.inra.pappso.xtandempipeline.grouping.HashSampleScanSetProt;
import fr.inra.pappso.xtandempipeline.grouping.SubGroup;
import fr.inra.pappso.xtandempipeline.sax_parse.msms_output;

public class print_fasta extends print_base {

	protected HashSet<Protein> prot_deja_ecris;

	public print_fasta() {
		super();
		logger.info("Print protein to fasta : "+this.toString());
	}

	public void print_header() throws Exception {
	}

	public void print_group_information(Group group) throws Exception {
		for(SubGroup  sg : group.getSubGroupSet()){
			for(HashSampleScanSetProt hprot : sg.getHashSampleScanSetProtList()){
				if (prot_deja_ecris.add(hprot.getMatch().get_protein_match())) {
					out.write(">"
							+ hprot.getMatch().get_protein_match().get_description()
							+ "\n");
					out.write(hprot.getMatch().get_protein_match().get_sequence()
							+ "\n");
				}
			}
		}
	}
	
	public String toString(){
		return("All proteins");
	}

	public HashSet<Protein> getProt_deja_ecris() {
		return prot_deja_ecris;
	}

	public void setProt_deja_ecris(HashSet<Protein> prot_deja_ecris) {
		this.prot_deja_ecris = prot_deja_ecris;
	}

	public void setOut(msms_output out) {
		this.out = out;
	}

}
