package fr.inra.pappso.xtandempipeline.filter_print;

import java.util.ArrayList;

import fr.inra.pappso.libodsstream.OdsDocWriter;
import fr.inra.pappso.xtandempipeline.class_msms.Match;
import fr.inra.pappso.xtandempipeline.class_msms.MsRun;
import fr.inra.pappso.xtandempipeline.class_msms.MsRunSet;
import fr.inra.pappso.xtandempipeline.grouping.Group;
import fr.inra.pappso.xtandempipeline.grouping.HashSampleScanSetProt;
import fr.inra.pappso.xtandempipeline.grouping.SubGroup;

public class print_ods_protein_to_indiv extends printOdsBase {

	public print_ods_protein_to_indiv(OdsDocWriter odsTable, MsRunSet sample) {
		super(odsTable, sample);

		logger.info("Print Protein liste file in Individual mode (ODS)");
	}

	public void print_header(MsRun samp) throws Exception {
		odsTable.writeLine();
		odsTable.writeCell(samp.getSampleName());
		// out.write(samp.getSampleName() + "\n");
		odsTable.writeLine();
		ArrayList<String> headStrList = new ArrayList<String>();
		headStrList.add("Group");
		headStrList.add("Sub-group");
		headStrList.add("Description");
		headStrList.add("log(E value)");
		headStrList.add("Coverage");
		headStrList.add("MW");
		headStrList.add("Spectra");
		headStrList.add("Specifics");
		headStrList.add("Uniques");
		headStrList.add("PAI");
		headStrList.add("Redundancy");

		for (String title : headStrList) {
			odsTable.writeCell(title);
		}

		/*
		 * String S = "Group" + "\t" + "Sub-group" + "\t" + "Description" + "\t"
		 * + "log(E value)" + "\t" + "Coverage" + "\t" + "MW" + "\t" + "Spectra"
		 * + "\t" + "Specifics" + "\t" + "Uniques" + "\t" + "PAI" + "\t" +
		 * "Redundancy" + "\n"; out.write(S);
		 */
	}

	public void print_group_information_to_sample(Group group, MsRun sample)
			throws Exception {
		for (SubGroup sg : group.getSubGroupSet().getSubGroupList()) {
			for (HashSampleScanSetProt hashProt : sg
					.getHashSampleScanSetProtList()) {
				odsTable.writeLine();
				// StringBuilder S = new StringBuilder();
				Match top = hashProt.getMatch();

				odsTable.writeCell("" + group.getNumber());
				// cell = row.newTableTableCellElement(0, "float");
				// cell.setOfficeValueTypeAttribute("float");
				// cell.setOfficeValueAttribute(new Double(group.getNumber()));

				odsTable.writeCell(this.get_subgroup_number(
						group, sg));

				odsTable.writeCell(top.get_protein_match()
						.get_description());

				odsTable.writeCell(new Double(top.get_protein_match()
						.get_evalue(sample)));

				odsTable.writeCell(new Double(top
						.get_coverage_to(sample)));

				odsTable.writeCell(new Double(top.get_protein_match()
						.get_mw()));

				odsTable.writeCell(new Double(top
						.get_valid_peptide_number_to(sample)));

				if (group.getSubGroupSet().size() > 1) {
					odsTable.writeCell(new Double(group.getNumberOfSpecificPeptideInSubGroupToSample(
							hashProt, sample)));
				} else {
					odsTable.writeCell("-");
					//S.append("\t" + "\"-\"");
				}
				odsTable.writeCell(new Double(top.get_unique_valid_peptide_number_to(sample)));

				odsTable.writeCell(new Double((float) top.get_spectra_numbers_to(sample)
						/ top.get_protein_match().get_PAI_count()));

				if (sg.getHashSampleScanSetProtSet().size() > 1) {
					odsTable.writeCell("* " + sg.getHashSampleScanSetProtSet().size());
					//S.append("* " + sg.getHashSampleScanSetProtSet().size());
				}
				//S.append("\n");
				//out.write(S.toString());

			}
		}
		odsTable.writeLine();
		// out.write("\n");
	}

}
