package fr.inra.pappso.xtandempipeline.filter_print;

import java.util.ArrayList;

import fr.inra.pappso.libodsstream.OdsDocWriter;
import fr.inra.pappso.xtandempipeline.class_msms.Match;
import fr.inra.pappso.xtandempipeline.grouping.Group;
import fr.inra.pappso.xtandempipeline.grouping.HashSampleScanSetPhospho;
import fr.inra.pappso.xtandempipeline.grouping.HashSampleScanSetProt;
import fr.inra.pappso.xtandempipeline.grouping.SubGroup;

public class print_ods_protein_to_phosphopeptide extends printOdsBase {

	public print_ods_protein_to_phosphopeptide(OdsDocWriter odsTable) {
		super(odsTable);
		logger.info("Print Protein liste file in Phospho mode");
	}

	public void print_header() throws Exception {
		odsTable.writeLine();
		// out.write(samp.getSampleName() + "\n");
		ArrayList<String> headStrList = new ArrayList<String>();
		headStrList.add("Group");
		headStrList.add("Sub-group");
		headStrList.add("Description");
		headStrList.add("MW");
		headStrList.add("Position");
		headStrList.add("Spectra");
		headStrList.add("Uniques");
		headStrList.add("Redundancy");

		for (String title : headStrList) {
			odsTable.writeCell(title);
		}

	}

	public void print_group_information(Group group) throws Exception {
		for (SubGroup sg : group.getSubGroupSet().getSubGroupList()) {
			for (HashSampleScanSetProt hashProt : sg
					.getHashSampleScanSetProtList()) {
				odsTable.writeLine();
				// StringBuilder S = new StringBuilder();
				Match top = hashProt.getMatch();
				HashSampleScanSetPhospho phospho = (HashSampleScanSetPhospho) hashProt;

				odsTable.writeCell("" + group.getNumber());

				// S.append(group.getNumber() + "\t"
				odsTable.writeCell(""
						+ this.get_subgroup_number(group, sg));
				// + this.get_subgroup_number(group, sg) + "\t"
				odsTable.writeCell(""
						+ top.get_protein_match().get_description());
				// + top.get_protein_match().get_description());

				odsTable.writeCell(new Double(top.get_protein_match()
						.get_mw()));

				// S.append("\t" + top.get_protein_match().get_mw());
				odsTable.writeCell(""
						+ phospho.getPhosphoPositionToPrint());

				// S.append("\t" + "\"" + phospho.getPhosphoPositionToPrint()
				// + "\"");

				odsTable.writeCell(new Double(phospho.size()));
				// S.append("\t" + phospho.size());
				odsTable.writeCell(new Double(phospho
						.getUniquePeptideHashSampleScan()));

				// S.append("\t" + phospho.getUniquePeptideHashSampleScan());
				// S.append("\t");
				if (sg.getHashSampleScanSetProtSet().size() > 1) {
					odsTable.writeCell("* "
							+ sg.getHashSampleScanSetProtSet().size());
					// S.append("* " + sg.getHashSampleScanSetProtSet().size());
				}
				// S.append("\n");

				// out.write(S.toString());
			}
		}
		odsTable.writeLine();
	}

}
