package fr.inra.pappso.xtandempipeline.filter_print;

import fr.inra.pappso.xtandempipeline.class_msms.Match;
import fr.inra.pappso.xtandempipeline.grouping.Group;
import fr.inra.pappso.xtandempipeline.grouping.HashSampleScanSetProt;
import fr.inra.pappso.xtandempipeline.grouping.SubGroup;
import fr.inra.pappso.xtandempipeline.sax_parse.msms_output;

public class print_protein_to_combined extends print_base {

	public print_protein_to_combined(msms_output out) {
		super(out);
		logger.info("Print Protein liste file in Combined mode");
	}

	public void print_header() throws Exception {
		String S = "Group" + "\t" + "Sub-group" + "\t" + "Description" + "\t"
				+ "log(E value)" + "\t" + "Coverage" + "\t" + "MW" + "\t"
				+ "Spectra" + "\t" + "Specific uniques" + "\t" + "Uniques"
				+ "\t" + "PAI" + "\t" + "Redundancy" + "\n";
		out.write(S);
	}

	public void print_group_information(Group group) throws Exception {
		for (SubGroup sg : group.getSubGroupSet().getSubGroupList()) {
			for (HashSampleScanSetProt hashProt : sg.getHashSampleScanSetProtList()) {
				StringBuilder S = new StringBuilder();
				Match top = hashProt.getMatch();
				
				S.append(group.getNumber() + "\t" + this.get_subgroup_number(group, sg) + "\t"
						+ top.get_protein_match().get_description());
				S.append("\t" + top.get_protein_match().get_evalue());
				S.append("\t" + top.get_coverage());
				S.append("\t" + top.get_protein_match().get_mw());
				S.append("\t" + top.get_valid_peptide_number());
				if(group.getSubGroupSet().size() > 1)
					S.append("\t"
							+ group.getNumberOfSpecificUniquePeptideInSubGroup(hashProt));
				else
					S.append("\t" + "\"-\"");
				S.append("\t" + top.get_unique_valid_peptide_number());
				S.append("\t");
				S.append((float) top.get_valid_peptide_number()
						/ top.get_protein_match().get_PAI_count() + "\t");
				if (sg.getHashSampleScanSetProtSet().size() > 1)
					S.append("* " + sg.getHashSampleScanSetProtSet().size());
				S.append("\n");
				
				out.write(S.toString());
			}
		}
		out.write("\n");
	}
}
