package fr.inra.pappso.xtandempipeline.filter_print;

import fr.inra.pappso.xtandempipeline.class_msms.Match;
import fr.inra.pappso.xtandempipeline.grouping.Group;
import fr.inra.pappso.xtandempipeline.grouping.HashSampleScanSetPhospho;
import fr.inra.pappso.xtandempipeline.grouping.HashSampleScanSetProt;
import fr.inra.pappso.xtandempipeline.grouping.SubGroup;
import fr.inra.pappso.xtandempipeline.sax_parse.msms_output;

public class print_protein_to_phosphopeptide extends print_base {

	public print_protein_to_phosphopeptide(msms_output out) {
		super(out);
		logger.info("Print Protein liste file in Phospho mode");
	}

	public void print_header() throws Exception {
		String S = "Group" + "\t" + "Sub-group" + "\t" + "Description" 
				+  "\t" + "MW" + "\t" + "Position" + "\t"
				+ "Spectra" + "\t" +  "Uniques" + "\t"
				+ "Redundancy" + "\n";
		out.write(S);
	}
	
	public void print_group_information(Group group) throws Exception {
		for (SubGroup sg : group.getSubGroupSet().getSubGroupList()) {
			for (HashSampleScanSetProt hashProt : sg.getHashSampleScanSetProtList()) {
				StringBuilder S = new StringBuilder();
				Match top = hashProt.getMatch();
				HashSampleScanSetPhospho phospho = (HashSampleScanSetPhospho) hashProt;
				
				S.append(group.getNumber() + "\t" + this.get_subgroup_number(group, sg) + "\t"
						+ top.get_protein_match().get_description());
				S.append("\t" + top.get_protein_match().get_mw());
				
				S.append("\t" + "\""+phospho.getPhosphoPositionToPrint()+"\"");
				
				S.append("\t" + phospho.size());

				S.append("\t" + phospho.getUniquePeptideHashSampleScan());
				S.append("\t");
				if (sg.getHashSampleScanSetProtSet().size() > 1)
					S.append("* " + sg.getHashSampleScanSetProtSet().size());
				S.append("\n");
				
				out.write(S.toString());
			}
		}
		out.write("\n");
	}

}
